/* IBM_PROLOG_BEGIN_TAG                                                   */
/* This is an automatically generated prolog.                             */
/*                                                                        */
/*                                                                        */
/*                                                                        */
/* IBM CONFIDENTIAL                                                       */
/*                                                                        */
/* OBJECT CODE ONLY SOURCE MATERIALS                                      */
/*                                                                        */
/* (C) COPYRIGHT International Business Machines Corp. 2012               */
/* All Rights Reserved                                                    */
/*                                                                        */
/* The source code for this program is not published or otherwise         */
/* divested of its trade secrets, irrespective of what has been           */
/* deposited with the U.S. Copyright Office.                              */
/*                                                                        */
/* IBM_PROLOG_END_TAG                                                     */
/* "@(#) 1.3 src/ppe/hpctq/source/include/hpcMIO_user.h, ppe.hpctq, ppe_rjunoq, rjunoqs001a 12/12/17 12:41:11" */

#if !defined(_HPCMIO_USER_H )
#define _HPCMIO_USER_H 

#if !defined(_LARGE_FILES)
#define _LARGE_FILES
#endif

#if !defined (_LARGEFILE64_SOURCE)
  #define _LARGEFILE64_SOURCE
#endif

#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <unistd.h>

#if !defined (USE_MIO_DEFINES)
  #define USE_MIO_DEFINES
#endif

#if defined(__linux__)
#define int64 long long
#endif

#define MIO_EXTRA_SKIP_MIO_FILES_FLAG      0x2
#define MIO_EXTRA_SKIP_MIO_DEFAULTS_FLAG   0x4
#define MIO_EXTRA_OPEN_FOR_UNLINK          0x8

#define MIO_EXTRA_COOKIE_OLD 0x7a78746b
#define MIO_EXTRA_COOKIE     0x7a78746c

struct mio_extra_old {
   int   cookie ;
   int   taskid ;
   int64 bufsiz ;
   char *modules ;
   char *logical_name ;
} ;
struct mio_extra {
   int   cookie ;
   int   taskid ;
   int64 bufsiz ;
   char *modules ;
   char *logical_name ;
   int   flags ;
   int   extra_errno ;
   int   reserved[8] ;
} ;

#define MIO_EXTRA_FLAG_SCRATCH 0x80000000

#if !defined(MIO_STRUCT_AIOCB)
#define MIO_STRUCT_AIOCB struct aiocb64
#define MIO_STRUCT_LIOCB struct liocb64
#endif

extern int MIO_open(char *, int, int, struct mio_extra *);
extern int MIO_open64(char *, int, int, struct mio_extra *);
extern int MIO_fstat64( int, struct stat64 *);
extern off_t   MIO_lseek(   int, off_t,   int);
extern off64_t MIO_lseek64( int, off64_t, int);
extern int MIO_ftruncate64( int, int64);
extern int MIO_read( int, void *, int);
extern int MIO_write( int, void *, int);
extern int MIO_close( int);
extern int MIO_fcntl( int, int, long *);
extern int MIO_ffinfo( int, int, struct diocapbuf *, int);
extern int MIO_fsync( int);
extern int64 MIO_str_to_long( char *);
extern int   MIO_str_to_long_vector(char *, int64*, int);
extern int MIO_aio_read64( int , MIO_STRUCT_AIOCB * ) ;
extern int MIO_aio_write64( int , MIO_STRUCT_AIOCB * ) ;
extern int MIO_aio_suspend64( int , MIO_STRUCT_AIOCB ** ) ;
extern int MIO_aio_nwait64( int , int , MIO_STRUCT_AIOCB ** ) ;
extern int MIO_aio_cancel64( int , MIO_STRUCT_AIOCB * ) ;
extern int MIO_lio_listio64( int , MIO_STRUCT_LIOCB **, int , void *) ;

extern int MIO_open_wrapper(char *, int, ...);
extern int MIO_fcntl_wrapper(int, int, ...);

#if defined(USE_MIO_DEFINES)

#define PP_NARG(...) \
         PP_NARG_(__VA_ARGS__,PP_RSEQ_N())

#define PP_NARG_(...) \
         PP_ARG_N(__VA_ARGS__)

#define PP_ARG_N(_1, _2, _3, _4, _5, _6, _7, _8, _9,_10, N, ...) N

#define PP_RSEQ_N() 10,9,8,7,6,5,4,3,2,1,0

#define open(fn, ...) MIO_open_wrapper(fn, PP_NARG(__VA_ARGS__), __VA_ARGS__)
#define open64(fn, ...) MIO_open_wrapper(fn, PP_NARG(__VA_ARGS__), __VA_ARGS__)
#define fcntl(fd, ...) MIO_fcntl_wrapper(fd, PP_NARG(__VA_ARGS__), __VA_ARGS__)

#define close(a)             MIO_close(a)

#define read(a,b,c)          MIO_read(a,b,c)

#define write(a,b,c)         MIO_write(a,b,c)

#define lseek(a,b,c)     MIO_lseek64(a,b,c)
#define lseek64(a,b,c)       MIO_lseek64(a,b,c)

#define ftruncate(a,b)   MIO_ftruncate64(a,b)
#define ftruncate64(a,b)     MIO_ftruncate64(a,b)

#define fsync(a)             MIO_fsync(a)

#define fstat(a,b)       MIO_fstat64(a,b)
#define fstat64(a,b)         MIO_fstat64(a,b)

#define ffinfo(a,b,c,d)      MIO_ffinfo(a,b,c,d)


#define aio_read64(a,b)      MIO_aio_read64(a,b)
#define aio_write64(a,b)     MIO_aio_write64(a,b)
#define aio_suspend64(a,b)   MIO_aio_suspend64(a,b)
#define aio_nwait(a,b,c)     MIO_aio_nwait64(a,b,c)
#define aio_cancel64(a,b)    MIO_aio_cancel64(a,b)
#define lio_listio64(a,b,c,d) MIO_lio_listio64(a,b,c,d)


#endif // USE_MIO_DEFINES

#endif  /* _HPCMIO_USER_H  */
